image:
  name: hashicorp/terraform:light
  entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'

stages:
  - validate
  - plan
  - apply
  - destroy

before_script:
  - rm -rf .terraform
  - terraform --version
  - terraform init -backend-config="bucket=$AWS_TF_STATE_BUCKET" -backend-config="region=$AWS_REGION" -backend-config="key=$CONTEXT-infrastructure/state"

validate:
  stage: validate
  script:
    - terraform validate

plan:
  stage: plan
  script:
    - terraform plan -out "planfile"
  dependencies:
    - validate
  artifacts:
    paths:
      - planfile

apply:
  stage: apply
  script:
    - terraform apply -input=false "planfile"
  when: manual
  dependencies:
    - plan

destroy:
  stage: destroy
  script:
    - terraform destroy -auto-approve
  when: manual
